
QGIS Application - Bug report #20930

Master fails to build wit sip-4.19.14

2019-01-07 11:22 AM - marisn -

Status: Open

Priority: Normal

Assignee:

Category: Python bindings / sipify

Affected QGIS version:3.5(master) Regression?: No

Operating System: Linux Easy fix?: No

Pull Request or Patch supplied:Yes Resolution:

Crashes QGIS or corrupts data:No Copied to github as #: 28749

Description

Gentoo ships following SIP versions:

dev-python/PyQt5-sip-4.19.14_pre1812231555:0/12

dev-python/sip-4.19.14_pre1812231555:0/12

Scanning dependencies of target python_module_qgis__gui

[ 98%] Building CXX object python/CMakeFiles/python_module_qgis__gui.dir/gui/sip_guipart0.cpp.o

[ 98%] Building CXX object python/CMakeFiles/python_module_qgis__core.dir/core/sip_corepart1.cpp.o

In file included from  build/python/core/sipAPI_core.h:10:0,

                 from  build/python/core/sip_corepart1.cpp:7:

 build/python/core/sip_corepart1.cpp:24614:105: error: expected ‘;’ at end of member declaration

     sipMeth = sipIsPyMethod(&sipGILState,const_cast<char *>(&sipPyMethods[17]),sipPySelf,SIP_NULLPTR,sipName_draw);

                                                                                                         ^

 build/python/core/sip_corepart1.cpp:24614:118: error: expected unqualified-id before ‘throw’

     sipMeth = sipIsPyMethod(&sipGILState,const_cast<char *>(&sipPyMethods[17]),sipPySelf,SIP_NULLPTR,sipName_draw);

                                                                                                                      ^    

 build/python/core/sip_corepart1.cpp:24919:6: error: declaration of ‘virtual void sipQgsPoint::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool) throw (QgsCsException)’ has a different

exception specifier

      ^          

 build/python/core/sip_corepart1.cpp:24614:10: note: from previous declaration ‘virtual void sipQgsPoint::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool)’

     sipMeth = sipIsPyMethod(&sipGILState,const_cast<char *>(&sipPyMethods[17]),sipPySelf,SIP_NULLPTR,sipName_draw);

          ^~~~~~~~~

In file included from  build/python/core/sipAPI_core.h:10:0,

                 from  build/python/core/sip_corepart1.cpp:7:

 build/python/core/sip_corepart1.cpp:289058:105: error: expected ‘;’ at end of member declaration

                                                                                                         ^

 build/python/core/sip_corepart1.cpp:289058:118: error: expected unqualified-id before ‘throw’

                                                                                                                      ^    

 build/python/core/sip_corepart1.cpp:289765:6: error: declaration of ‘virtual void sipQgsTriangle::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool) throw (QgsCsException)’ has a different

exception specifier

             catch (...)

      ^      ~~~~~~~

 build/python/core/sip_corepart1.cpp:289058:10: note: from previous declaration ‘virtual void sipQgsTriangle::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool)’
          ^        

In file included from  build/python/core/sipAPI_core.h:10:0,

                 from  build/python/core/sip_corepart1.cpp:7:

 build/python/core/sip_corepart1.cpp:299186:105: error: expected ‘;’ at end of member declaration

 {

                                                                                                         ^

 build/python/core/sip_corepart1.cpp:299186:118: error: expected unqualified-id before ‘throw’

 {

                                                                                                                      ^    

 build/python/core/sip_corepart1.cpp:299499:6: error: declaration of ‘virtual void sipQgsPolygon::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool) throw (QgsCsException)’ has a different

exception specifier

 #include "qgspoint.h" 

      ^~~~~~~~~~~~~

 build/python/core/sip_corepart1.cpp:299186:10: note: from previous declaration ‘virtual void sipQgsPolygon::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool)’

 {

          ^        

In file included from  build/python/core/sipAPI_core.h:10:0,

                 from  build/python/core/sip_corepart1.cpp:7:

 build/python/core/sip_corepart1.cpp:301414:105: error: expected ‘;’ at end of member declaration

             catch (...)

                                                                                                         ^

 build/python/core/sip_corepart1.cpp:301414:118: error: expected unqualified-id before ‘throw’

             catch (...)

                                                                                                                      ^    

 build/python/core/sip_corepart1.cpp:301769:6: error: declaration of ‘virtual void sipQgsMultiPolygon::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool) throw (QgsCsException)’ has a different

exception specifier

     SIP_NULLPTR,

      ^~~~~~~~~~~       

 build/python/core/sip_corepart1.cpp:301414:10: note: from previous declaration ‘virtual void

sipQgsMultiPolygon::transform(const QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool)’

             catch (...)

          ^  ~~~~~~

In file included from  build/python/core/sipAPI_core.h:10:0,

                 from  build/python/core/sip_corepart1.cpp:7:

 build/python/core/sip_corepart1.cpp:303795:105: error: expected ‘;’ at end of member declaration

             {

                                                                                                         ^

 build/python/core/sip_corepart1.cpp:303795:118: error: expected unqualified-id before ‘throw’

             {

                                                                                                                      ^    

 build/python/core/sip_corepart1.cpp:304456:6: error: declaration of ‘virtual void sipQgsMultiSurface::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool) throw (QgsCsException)’ has a different

exception specifier

         return  ::QgsMultiLineString::insertGeometry(a0,a1);

      ^  ~~~~~~~~~~~~~~~

 build/python/core/sip_corepart1.cpp:303795:10: note: from previous declaration ‘virtual void

sipQgsMultiSurface::transform(const QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool)’

             {

          ^  ~     
In file included from  build/python/core/sipAPI_core.h:10:0,

                 from  build/python/core/sip_corepart1.cpp:7:

 build/python/core/sip_corepart1.cpp:306116:105: error: expected ‘;’ at end of member declaration

     return SIP_NULLPTR;

                                                                                                         ^

 build/python/core/sip_corepart1.cpp:306116:118: error: expected unqualified-id before ‘throw’

     return SIP_NULLPTR;

                                                                                                                      ^    

 build/python/core/sip_corepart1.cpp:306777:6: error: declaration of ‘virtual void sipQgsMultiPoint::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool) throw (QgsCsException)’ has a different

exception specifier

 }

      ^               

 build/python/core/sip_corepart1.cpp:306116:10: note: from previous declaration ‘virtual void sipQgsMultiPoint::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool)’

     return SIP_NULLPTR;

          ^~~~~~~~~

In file included from  build/python/core/sipAPI_core.h:10:0,

                 from  build/python/core/sip_corepart1.cpp:7:

 build/python/core/sip_corepart1.cpp:308588:105: error: expected ‘;’ at end of member declaration

                                                                                                         ^

 build/python/core/sip_corepart1.cpp:308588:118: error: expected unqualified-id before ‘throw’

                                                                                                                      ^    

 build/python/core/sip_corepart1.cpp:308943:6: error: declaration of ‘virtual void sipQgsMultiLineString::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool) throw (QgsCsException)’ has a different

exception specifier

 #line 313223 " build/python/core/sip_corepart1.cpp" 

      ^~~~~~~~~~~~~~~~~~~~~

 build/python/core/sip_corepart1.cpp:308588:10: note: from previous declaration ‘virtual void

sipQgsMultiLineString::transform(const QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool)’

          ^        

In file included from  build/python/core/sipAPI_core.h:10:0,

                 from  build/python/core/sip_corepart1.cpp:7:

 build/python/core/sip_corepart1.cpp:310927:105: error: expected ‘;’ at end of member declaration

         }

                                                                                                         ^

 build/python/core/sip_corepart1.cpp:310927:118: error: expected unqualified-id before ‘throw’

         }

                                                                                                                      ^    

 build/python/core/sip_corepart1.cpp:311588:6: error: declaration of ‘virtual void sipQgsMultiCurve::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool) throw (QgsCsException)’ has a different

exception specifier

             Py_BEGIN_ALLOW_THREADS

      ^      ~~~~~~~~~

 build/python/core/sip_corepart1.cpp:310927:10: note: from previous declaration ‘virtual void sipQgsMultiCurve::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool)’

         }

          ^        

In file included from  build/python/core/sipAPI_core.h:10:0,

                 from  build/python/core/sip_corepart1.cpp:7:
 build/python/core/sip_corepart1.cpp:313352:105: error: expected ‘;’ at end of member declaration

     }

                                                                                                         ^

 build/python/core/sip_corepart1.cpp:313352:118: error: expected unqualified-id before ‘throw’

     }

                                                                                                                      ^    

 build/python/core/sip_corepart1.cpp:314052:6: error: declaration of ‘virtual void sipQgsLineString::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool) throw (QgsCsException)’ has a different

exception specifier

     {SIP_MLNAME_CAST(sipName_isEmpty), meth_QgsLineString_isEmpty, METH_VARARGS,

SIP_MLDOC_CAST(doc_QgsLineString_isEmpty)},

      ^~~~~~~~~~~~~~~~

 build/python/core/sip_corepart1.cpp:313352:10: note: from previous declaration ‘virtual void sipQgsLineString::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool)’

     }

          ^        

In file included from  build/python/core/sipAPI_core.h:10:0,

                 from  build/python/core/sip_corepart1.cpp:7:

 build/python/core/sip_corepart1.cpp:325529:105: error: expected ‘;’ at end of member declaration

     sipMeth = sipIsPyMethod(&sipGILState,const_cast<char

*>(&sipPyMethods[3]),sipPySelf,SIP_NULLPTR,sipName_childGeometry);

                                                                                                         ^

 build/python/core/sip_corepart1.cpp:325529:118: error: expected unqualified-id before ‘throw’

     sipMeth = sipIsPyMethod(&sipGILState,const_cast<char

*>(&sipPyMethods[3]),sipPySelf,SIP_NULLPTR,sipName_childGeometry);

                                                                                                                      ^~~~~

 build/python/core/sip_corepart1.cpp:325884:6: error: declaration of ‘virtual void sipQgsGeometryCollection::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool) throw (QgsCsException)’ has a different

exception specifier

 double sipQgsAbstractGeometry::length() const

      ^~~~~~~~~~~~~~~~~~~~~~~~

 build/python/core/sip_corepart1.cpp:325529:10: note: from previous declaration ‘virtual void

sipQgsGeometryCollection::transform(const QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool)’

     sipMeth = sipIsPyMethod(&sipGILState,const_cast<char

*>(&sipPyMethods[3]),sipPySelf,SIP_NULLPTR,sipName_childGeometry);

          ^~~~~~~~~

In file included from  build/python/core/sipAPI_core.h:10:0,

                 from  build/python/core/sip_corepart1.cpp:7:

 build/python/core/sip_corepart1.cpp:329950:105: error: expected ‘;’ at end of member declaration

         {SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR,

SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR},

                                                                                                         ^

 build/python/core/sip_corepart1.cpp:329950:118: error: expected unqualified-id before ‘throw’

         {SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR,

SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR},

                                                                                                                      ^~~~~

 build/python/core/sip_corepart1.cpp:330595:6: error: declaration of ‘virtual void sipQgsAbstractGeometry::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool) throw (QgsCsException)’ has a different

exception specifier

      ^                     

 build/python/core/sip_corepart1.cpp:329950:10: note: from previous declaration ‘virtual void

sipQgsAbstractGeometry::transform(const QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool)’
         {SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR,

SIP_NULLPTR, SIP_NULLPTR, SIP_NULLPTR},

          ^~~~~~~~~

In file included from  build/python/core/sipAPI_core.h:10:0,

                 from  build/python/core/sip_corepart1.cpp:7:

 build/python/core/sip_corepart1.cpp:334693:105: error: expected ‘;’ at end of member declaration

                                                                                                         ^

 build/python/core/sip_corepart1.cpp:334693:118: error: expected unqualified-id before ‘throw’

                                                                                                                      ^    

 build/python/core/sip_corepart1.cpp:335402:6: error: declaration of ‘virtual void sipQgsCurvePolygon::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool) throw (QgsCsException)’ has a different

exception specifier

 "\n" 

      ^                 

 build/python/core/sip_corepart1.cpp:334693:10: note: from previous declaration ‘virtual void

sipQgsCurvePolygon::transform(const QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool)’

          ^        

In file included from  build/python/core/sipAPI_core.h:10:0,

                 from  build/python/core/sip_corepart1.cpp:7:

 build/python/core/sip_corepart1.cpp:339079:105: error: expected ‘;’ at end of member declaration

             sipRes = (sipSelfWasArg ? sipCpp-> ::QgsCompoundCurve::moveVertex(*a0,*a1) : sipCpp->moveVertex(*a0,*a1));

                                                                                                         ^

 build/python/core/sip_corepart1.cpp:339079:118: error: expected unqualified-id before ‘throw’

             sipRes = (sipSelfWasArg ? sipCpp-> ::QgsCompoundCurve::moveVertex(*a0,*a1) : sipCpp->moveVertex(*a0,*a1));

                                                                                                                      ^    

 build/python/core/sip_corepart1.cpp:339386:6: error: declaration of ‘virtual void sipQgsSurface::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool) throw (QgsCsException)’ has a different

exception specifier

             Py_BEGIN_ALLOW_THREADS

      ^      ~~~~~~

 build/python/core/sip_corepart1.cpp:339079:10: note: from previous declaration ‘virtual void sipQgsSurface::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool)’

             sipRes = (sipSelfWasArg ? sipCpp-> ::QgsCompoundCurve::moveVertex(*a0,*a1) : sipCpp->moveVertex(*a0,*a1));

          ^  ~~~~~~

In file included from  build/python/core/sipAPI_core.h:10:0,

                 from  build/python/core/sip_corepart1.cpp:7:

 build/python/core/sip_corepart1.cpp:340774:105: error: expected ‘;’ at end of member declaration

                                                                                                         ^

 build/python/core/sip_corepart1.cpp:340774:118: error: expected unqualified-id before ‘throw’

                                                                                                                      ^    

 build/python/core/sip_corepart1.cpp:341449:6: error: declaration of ‘virtual void sipQgsCompoundCurve::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool) throw (QgsCsException)’ has a different

exception specifier

             try

      ^      ~~~         

 build/python/core/sip_corepart1.cpp:340774:10: note: from previous declaration ‘virtual void

sipQgsCompoundCurve::transform(const QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool)’
          ^        

In file included from  build/python/core/sipAPI_core.h:10:0,

                 from  build/python/core/sip_corepart1.cpp:7:

 build/python/core/sip_corepart1.cpp:348768:105: error: expected ‘;’ at end of member declaration

 void sipQgsCurve::transform(const  ::QTransform& a0,double a1,double a2,double a3,double a4)

                                                                                                         ^

 build/python/core/sip_corepart1.cpp:348768:118: error: expected unqualified-id before ‘throw’

 void sipQgsCurve::transform(const  ::QTransform& a0,double a1,double a2,double a3,double a4)

                                                                                                                      ^    

 build/python/core/sip_corepart1.cpp:349448:6: error: declaration of ‘virtual void sipQgsCircularString::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool) throw (QgsCsException)’ has a different

exception specifier

     }

      ^                   

 build/python/core/sip_corepart1.cpp:348768:10: note: from previous declaration ‘virtual void

sipQgsCircularString::transform(const QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool)’

 void sipQgsCurve::transform(const  ::QTransform& a0,double a1,double a2,double a3,double a4)

          ^~~~~~~~~

In file included from  build/python/core/sipAPI_core.h:10:0,

                 from  build/python/core/sip_corepart1.cpp:7:

 build/python/core/sip_corepart1.cpp:353014:105: error: expected ‘;’ at end of member declaration

     {(void *)slot_QgsBox3d___eq__, eq_slot},

                                                                                                         ^

 build/python/core/sip_corepart1.cpp:353014:118: error: expected unqualified-id before ‘throw’

     {(void *)slot_QgsBox3d___eq__, eq_slot},

                                                                                                                      ^    

 build/python/core/sip_corepart1.cpp:353576:6: error: declaration of ‘virtual void sipQgsCurve::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool) throw (QgsCsException)’ has a different

exception specifier

                 return SIP_NULLPTR;

      ^          

 build/python/core/sip_corepart1.cpp:353014:10: note: from previous declaration ‘virtual void sipQgsCurve::transform(const

QgsCoordinateTransform&, QgsCoordinateTransform::TransformDirection, bool)’

     {(void *)slot_QgsBox3d___eq__, eq_slot},

          ^~~~~~~~~

make[2]: *** [python/CMakeFiles/python_module_qgis__core.dir/build.make:560:

python/CMakeFiles/python_module_qgis__core.dir/core/sip_corepart1.cpp.o] Error 1

make[1]: *** [CMakeFiles/Makefile2:3537: python/CMakeFiles/python_module_qgis__core.dir/all] Error 2

make[1]: *** Waiting for unfinished jobs....

[ 98%] Building CXX object python/CMakeFiles/python_module_qgis__gui.dir/gui/sip_guipart1.cpp.o

[ 98%] Building CXX object python/CMakeFiles/python_module_qgis__gui.dir/gui/sip_guipart2.cpp.o

[ 98%] Building CXX object python/CMakeFiles/python_module_qgis__gui.dir/gui/sip_guipart3.cpp.o

 build/python/gui/sip_guipart3.cpp:176775:10: error: ‘void

sipQgsAttributeFormRelationEditorWidget::createSearchWidgetWrappers()’ marked ‘override’, but does not override

             Py_BEGIN_ALLOW_THREADS

          ^  ~~~~~~~~~~~~~~~~~~~~~~ 

 build/python/gui/sip_guipart3.cpp:180456:10: error: ‘void sipQgsAttributeFormEditorWidget::createSearchWidgetWrappers()’

marked ‘override’, but does not override

                 sipRaiseUnknownException();

          ^      ~~~~~~~~~~~~~~~~~~~

make[2]: *** [python/CMakeFiles/python_module_qgis__gui.dir/build.make:918:

python/CMakeFiles/python_module_qgis__gui.dir/gui/sip_guipart3.cpp.o] Error 1

make[2]: *** Waiting for unfinished jobs....
make[1]: *** [CMakeFiles/Makefile2:3640: python/CMakeFiles/python_module_qgis__gui.dir/all] Error 2

make: *** [Makefile:152: all] Error 2

History

#1 - 2019-02-10 07:30 PM - Chris Mayo

Fixed here:

https://github.com/qgis/QGIS/commit/1a87fce33c0ba9d230940a7787cd5cc0776de3a7

Also need to upgrade to sip-4.19.14.

#2 - 2019-02-11 10:40 AM - Giovanni Manghi

- Pull Request or Patch supplied changed from No to Yes
https://github.com/qgis/QGIS/commit/1a87fce33c0ba9d230940a7787cd5cc0776de3a7

